#!/usr/bin/env python

"""
Iterator classes for indexing.

Copyright (C) 2011 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

class Iterator:

    "An iterator over records employing record accessors."

    def __init__(self, accessor):
        self.accessor = accessor
        self.records = None
        self.iterator = None

    def set_records(self, records):
        self.records = records

    def __iter__(self):
        self.iterator = iter(self.records)
        self.accessor.reset()
        return self

    def next(self):
        if self.iterator is None:
            iter(self)
        record = self.iterator.next()
        return self.accessor.get_key(record), record

# vim: tabstop=4 expandtab shiftwidth=4
